#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 210;
bool ok[MAX_N][MAX_N];
int n, m;
int ans[MAX_N];

void recurse(int x, int mask) {
    if(x == m) {
        for(int i = 0; i < n; i ++) {
            if((1 << i)& mask) {
                ans[i] ++;
            }
        }
        return;
    }

    int cnt[2] = {0, 0};
    for(int i = 0; i < n; i ++) {
        if((1 << i) & mask) {
            cnt[ok[i][x]] ++;
        }
    }

    if(cnt[1] >= cnt[0]) {
        for(int i = 0; i < n; i ++) {
            if((1 << i) & mask) {
                if(!ok[i][x]) {
                    mask -= (1 << i);
                }
            }
        }
    } else {
        for(int i = 0; i < n; i ++) {
            if((1 << i) & mask) {
                if(ok[i][x]) {
                    mask -= (1 << i);
                }
            }
        }
    }

    recurse(x + 1, mask);
}

void solve_slow() {
    for(int i = 0; i < n; i ++) {
        ans[i] = 0;
    }

    for(int i = 0; i < (1 << n); i ++) {
        recurse(0, i);
    }

    for(int i = 0; i < n; i ++) {
        ans[i] %= mod;
        //cout << ans[i] % mod << " ";
    }
}

//~~~~~~~~~~~~~~
ll who[MAX_N];

ll comb[MAX_N][MAX_N];

ll dp[MAX_N][MAX_N];

ll solve(ll x) {
    for(ll i = 0; i <= m; i ++) {
        who[i] = 0;
    }
    for(ll i = 0; i <= m + 1; i ++) {
        for(ll j = 0; j <= n; j ++) {
            dp[i][j] = 0;
        }
    }

    for(ll i = 0; i < n; i ++) {
        if(i == x) { continue; }
        ll when = m;
        for(ll j = 0; j < m; j ++) {
            if(ok[x][j] != ok[i][j]) {
                when = j;
                break;
            }
        }
        who[when] ++;
    }

    ll sum = who[m] + 1;
    for(ll i = 0; i <= who[m] + 1; i ++) {
        dp[0][i + 1] = comb[sum - 1][i];
    }
    for(ll i = 0; i < m; i ++) {
        ll group = who[m - 1 - i];
        for(ll j = 0; j <= sum; j ++) {
            for(ll nw = 0; nw <= group && nw <= j; nw ++) {
                if(!ok[x][m - 1 - i] && nw == j) { continue; }
                dp[i + 1][j + nw] += (comb[group][nw] * dp[i][j]) % mod;
                dp[i + 1][j + nw] %= mod;
            }
        }

        sum += group;
    }

    ll ret = 0;
    for(ll i = 0; i <= n; i ++) {
        ret = (ret + dp[m][i]) % mod;
    }
    return ret;
}

void init() {
    comb[0][0] = 1;
    for(int i = 1; i < MAX_N; i ++) {
        for(int j = 1; j < MAX_N; j ++) {
            comb[i][j] = (comb[i - 1][j] + comb[i - 1][j - 1]) % mod;
        }
        comb[i][0] = 1;
    }
}

int ans2[MAX_N];

void solve_fast() {
    for(int i = 0; i < n; i ++) {
        ans2[i] = solve(i);
    }
}

void test() {
    auto is_prime = [&](const ll x) {
        for(int i = 2; i * i <= x; i ++) {
            if(x % i == 0) {
                return false;;
            }
        }
        return true;
    };

    while(true) {
        n = rand() % 9 + 1, m = rand() % 5 + 1;
        mod = 1e9 + 7;
        init();
        for(int i = 0; i < n; i ++) {
            for(int j = 0; j < m; j ++) {
                ok[i][j] = rand() & 1;
            }
        }
        solve_fast();
        solve_slow();
        bool bad = false;
        for(int i = 0; i < n; i ++) {
            if(ans[i] != ans2[i]) {
                bad = true;
                break;
            }
        }
        cout << ".";
        if(bad) {
            cout << endl << n << " " << m << " " << mod << endl;
            for(int i = 0; i < n; i ++) {
                for(int j = 0; j < m; j ++) {
                    cout << ok[i][j];
                }
                cout << endl;
            }
            for(int i = 0; i < n; i ++) {
                cout << ans[i] << " ";
            }
            cout << endl;
            for(int i = 0; i < n; i ++) {
                cout << ans2[i] << " ";
            }
            cout << endl;
            exit(-1);
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL


    //test();

    cin >> n >> m >> mod;
    init();
    for(ll i = 0; i < n; i ++) {
        string s;
        cin >> s;
        for(ll j = 0; j < m; j ++) {
            ok[i][j] = (s[j] == '1');
        }
    }
    for(int i = 0; i < n; i ++) {
        cout << solve(i) << " ";
    }
    cout << endl;

    return 0;
}

