#include "minimize.h"
#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int SZ,skip,inp[nmax];

long long saved[nmax][25];

set< pair<long long, pair<int,int> > > seen[25];

int ask(int l,int r)
{
    if(l==0||r==SZ+1)return 0;

    return inp[l]^inp[r];
}

void initialize(int n, int k, std::vector <int> a)
{
    SZ=n;
    skip=k;
    for(int i=1;i<=SZ;i++)inp[i]=a[i-1];

    for(int i=0;i<=n+1;i++)
    {
        long long sum=0;

        for(int j=i+1;j<=n+1&&j-i-1<=skip;j++)
        {
            sum+=ask(j-1,j);

            saved[i][j-i-1]=sum-ask(i,j);

            seen[j-i-1].insert({saved[i][j-i-1],{i,j}});
        }
    }
}

void modify(int pos, int val)
{
    pos++;

    inp[pos]=val;

    /*
    cout<<"inp: ";cout<<endl;
    for(int i=1;i<=SZ;i++)
        cout<<inp[i]<<" ";cout<<endl;
    */

    for(int i=max(0,pos-skip);i<=pos;i++)
    {
        long long sum=0;

        for(int j=i+1;j<=SZ+1&&j-i-1<=skip;j++)
        {
            seen[j-i-1].erase({saved[i][j-i-1],{i,j}});

            sum+=ask(j-1,j);

            saved[i][j-i-1]=sum-ask(i,j);

            seen[j-i-1].insert({saved[i][j-i-1],{i,j}});
        }
    }
}

vector< pair<long long,int> > edges[nmax];

long long dp[nmax][25];

long long rec(int pos,int to_skip)
{
    //cout<<"rec "<<pos<<" "<<to_skip<<endl;

    if(pos<=0)return 0;

    if(dp[pos][to_skip]!=-1)return dp[pos][to_skip];

    long long ret=rec(pos-1,to_skip);

    for(auto w:edges[pos])
        if(pos-w.second-1<=to_skip)
            ret=max(ret,w.first+rec(w.second,to_skip-(pos-w.second-1)));

    dp[pos][to_skip]=ret;
    return ret;
}


long long calculate()
{
    long long score=0;
    for(int i=2;i<=SZ;i++)
        score+=(inp[i-1]^inp[i]);

    vector< pair<long long, pair<int,int> > > interesting={};

    for(int save=1;save<=skip;save++)
    {
        int take=seen[save].size();
        take=min(take,(save+1)*(skip-save)+1);

        //cout<<"save= "<<save<<" take= "<<take<<endl;

        set< pair<long long, pair<int,int> > > ::iterator it=seen[save].end();
        it--;

        for(int t=1;t<=take;t++)
        {
            interesting.push_back(*it);
            it--;
        }
    }

    for(int i=0;i<=SZ+1;i++)edges[i]={};

    /*
    cout<<"interesting"<<endl;

    cout<<"score= "<<score<<endl;
    for(auto w:interesting)
        cout<<w.first<<" "<<w.second.first<<" "<<w.second.second<<endl;
    cout<<"---"<<endl;
    */

    for(auto w:interesting)
        edges[w.second.second].push_back({w.first,w.second.first});

    for(int i=0;i<=SZ+1;i++)
        for(int j=0;j<=skip;j++)
            dp[i][j]=-1;

    return score-rec(SZ+1,skip);
}
/*
void eval()
{
    int kk=20;

    int sum=0;
    for(int c=1;c<=kk;c++)
        sum+=(c+1)*(kk-c)+1;

    cout<<sum<<endl;
}

int main() {

  std::cin.tie(NULL);
  std::ios_base::sync_with_stdio(false);

  // Note that every vector is 1 indexed

  int n, k;
  std::cin >> n >> k;
  std::vector <int> a(n, 0);
  for (int i = 0; i < n ; ++i)
    std::cin >> a[i];

  initialize(n, k, a);

  int q;
  std::cin >> q;


  std::vector <long long> ans;
  for (; q > 0 ; --q) {
    int type;
    std::cin >> type;
    if (type == 1) {
      // update nr positions
      int pos, val;
      std::cin >> pos >> val;

      if (pos < 0 || pos >= n) {
        std::cerr << "BAD UPDATE INDEX" << std::endl;
        exit(1);
      }

      modify(pos, val);
    } else if (type == 0) {
      // query
      cout<<"calculate= "<<calculate()<<endl;
      //ans.push_back(calculate());
    } else {
      // bad operation type
      std::cerr << "BAD OPERATION TYPE" << std::endl;
      exit(1);
    }
  }

  return 0;
}
*/
  /*
    0 - query
    1 - update

    update structure:
    1 pos val
  */
