#include "minimize.h"
#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int SZ,skip,inp[nmax];

long long vals[25][nmax];

struct info
{
    long long lazy;
    long long MX;
    int id_MX;
};

info actual(info a)
{
    a.MX+=a.lazy;
    a.lazy=0;
    return a;
}

info my_merge(info a,info b)
{
    a=actual(a);
    b=actual(b);

    if(a.MX<b.MX)return b;
    return a;
}

info tree[21][(1<<18)+42];

int ask(int l,int r)
{
    if(l==0||r==SZ+1)return 0;

    return inp[l]^inp[r];
}

void push(int id,int node)
{
    tree[id][node*2].lazy+=tree[id][node].lazy;
    tree[id][node*2+1].lazy+=tree[id][node].lazy;

    tree[id][node].lazy=0;
}

void update(int id,int node,int l,int r,int lq,int rq,long long val)
{
    if(l==lq&&r==rq)
    {
        tree[id][node].lazy+=val;
        return;
    }

    push(id,node);

    int av=(l+r)/2;

    if(lq<=av)update(id,node*2,l,av,lq,min(av,rq),val);
    if(av<rq)update(id,node*2+1,av+1,r,max(av+1,lq),rq,val);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);
}
void update_set(int id,int node,int l,int r,int pos,long long val)
{
    if(l==r)
    {
        tree[id][node].lazy=0;
        tree[id][node].MX=val;
        return;
    }

    push(id,node);

    int av=(l+r)/2;

    if(pos<=av)update_set(id,node*2,l,av,pos,val);
    else update_set(id,node*2+1,av+1,r,pos,val);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);
}

void build(int id,int node,int l,int r)
{
    if(l==r)
    {
        tree[id][node].lazy=0;
        tree[id][node].id_MX=l;
        tree[id][node].MX=vals[id][l];
        return;
    }

    int av=(l+r)/2;

    build(id,node*2,l,av);
    build(id,node*2+1,av+1,r);

    tree[id][node]=my_merge(tree[id][node*2],tree[id][node*2+1]);
}

void initialize(int n, int k, std::vector <int> a)
{
    SZ=n;
    skip=k;
    for(int i=1;i<=SZ;i++)inp[i]=a[i-1];

    for(int i=0;i<=n+1;i++)
    {
        long long sum=0;

        for(int j=i+1;j<=n+1&&j-i-1<=skip;j++)
        {
            sum+=ask(j-1,j);

            vals[j-i-1][i]=sum-ask(i,j);
        }
    }

    for(int i=1;i<=skip;i++)
        build(i,1,0,SZ-i);
}

void modify(int pos, int val)
{
    pos++;

    //jump over
    for(int i=1;i<=skip;i++)
    {
        int lq=max(0,pos-i);
        int rq=min(pos-1,SZ-i);

        if(lq<=rq)
        {
            long long value_was=0;

            if(pos-1>=1)value_was+=(inp[pos-1]^inp[pos])-(inp[pos-1]^val);
            if(pos+1<=SZ)value_was+=(inp[pos]^inp[pos+1])-(inp[pos+1]^val);

            value_was=-value_was;

            update(i,1,0,SZ-i,lq,rq,value_was);

            //cout<<"update range "<<i<<" -> "<<lq<<" "<<rq<<" "<<value_was<<endl;
        }
    }

    //use pos


    inp[pos]=val;

    /*
    cout<<"inp: ";cout<<endl;
    for(int i=1;i<=SZ;i++)
        cout<<inp[i]<<" ";cout<<endl;
    */

    for(int i=max(0,pos-skip-1);i<=pos;i++)
    {
        long long sum=0;

        for(int j=i+1;j<=SZ+1&&j-i-1<=skip;j++)
        {
            sum+=ask(j-1,j);

            if(i==pos||j==pos)
            {
                long long val=sum-ask(i,j);

                int id=j-i-1;

                update_set(id,1,0,SZ-id,i,val);

                //cout<<"update_set "<<id<<" -> "<<i<<" "<<val<<endl;
            }
        }
    }
}

vector< pair<long long, pair<int/*left*/,int/*cost*/> > > edges[nmax];

long long dp[nmax][25];

long long rec(int pos,int to_skip)
{
    //cout<<"rec "<<pos<<" "<<to_skip<<endl;

    if(pos<0)return 0;

    if(dp[pos][to_skip]!=-1)return dp[pos][to_skip];

    long long ret=rec(pos-1,to_skip);

    for(auto w:edges[pos])
        if(w.second.second<=to_skip)
            ret=max(ret,w.first+rec(w.second.first,to_skip-w.second.second));

    dp[pos][to_skip]=ret;
    return ret;
}


long long calculate()
{
    //cout<<"inp: ";for(int i=1;i<=SZ;i++)cout<<inp[i]<<" ";cout<<endl;

    long long score=0;
    for(int i=2;i<=SZ;i++)
        score+=(inp[i-1]^inp[i]);

    vector< pair<long long, pair<int,int> > > interesting={};

    for(int save=1;save<=skip;save++)
    {
        int take=SZ+1-save;
        take=min(take,(save+1)*(skip-save)+1+skip);

        //cout<<"save= "<<save<<" take= "<<take<<endl;

        vector< pair<int,long long> > to_set_back={};

        for(int t=1;t<=take;t++)
        {
            info cur=actual(tree[save][1]);

            interesting.push_back({cur.MX,{cur.id_MX,cur.id_MX+save+1}});

            to_set_back.push_back({cur.id_MX,cur.MX});

            update_set(save,1,0,SZ-save,cur.id_MX,-1e18);
        }

        for(auto w:to_set_back)
            update_set(save,1,0,SZ-save,w.first,w.second);
    }

    /*
    cout<<"interesting:"<<endl;
    for(auto w:interesting)
        cout<<w.first<<" "<<w.second.first<<" "<<w.second.second<<endl;
    cout<<"---"<<endl;
    */

    vector<int> rights={};
    for(auto w:interesting)
        rights.push_back(w.second.second);

    sort(rights.begin(),rights.end());

    for(int i=0;i<=rights.size()+1;i++)edges[i]={};

    for(auto w:interesting)
    {
        int p=lower_bound(rights.begin(),rights.end(),w.second.second)-rights.begin();
        int q=upper_bound(rights.begin(),rights.end(),w.second.first)-rights.begin();
        q--;

        edges[p].push_back({w.first,{q,w.second.second-w.second.first-1}});
    }

    for(int i=0;i<=rights.size();i++)
        for(int j=0;j<=skip;j++)
            dp[i][j]=-1;

    return score-rec(rights.size()-1,skip);
}
/*
long long old(int pos,int to_skip)
{
    //cout<<"rec "<<pos<<" "<<to_skip<<endl;

    if(to_skip>=pos-1||pos==1)return 0;

    if(dp[pos][to_skip]!=-1)return dp[pos][to_skip];

    long long ret=1e18;

    for(int j=pos-1;j>=1&&(pos-1-j)<=to_skip;j--)
        ret=min(ret,old(j,to_skip-(pos-1-j))+(inp[j]^inp[pos]));

    //cout<<"pos= "<<pos<<" to_skip= "<<to_skip<<" -> "<<ret<<endl;

    dp[pos][to_skip]=ret;
    return ret;
}

long long dumb()
{
    for(int i=0;i<=SZ;i++)
        for(int j=0;j<=skip;j++)
            dp[i][j]=-1;

    long long ret=1e18;
    for(int i=SZ;i>=0&&(SZ-i)<=skip;i--)
        ret=min(ret,old(i,skip-(SZ-i)));

    return ret;
}


void eval()
{
    int kk=20;

    int sum=0;
    for(int c=1;c<=kk;c++)
        sum+=(c+1)*(kk-c)+1;

    cout<<sum<<endl;
}

int main() {

  std::cin.tie(NULL);
  std::ios_base::sync_with_stdio(false);

  // Note that every vector is 1 indexed

  int n, k;

    mt19937 rng(42);

    int C=(1<<16);
  n=1e5;
  k=20;
  //std::cin >> n >> k;
  std::vector <int> a(n, 0);
  for (int i = 0; i < n ; ++i)
    //std::cin >> a[i];
    a[i]=rng()%C;

  initialize(n, k, a);

  for(int i=0;i<50000;i++)
    modify(2*i,rng()%C);

    return 0;

  int q;
  //std::cin >> q;

  q=1e5;

  std::vector <long long> ans;
  for (; q > 0 ; --q) {
        //for(int i=1;i<=SZ;i++)cout<<inp[i]<<" ";cout<<endl;


    int type;
    //std::cin >> type;
    type=q%2;

    if (type == 1) {
      // update nr positions
      int pos, val;
      //std::cin >> pos >> val;
      pos=rng()%n;
      val=rng()%C+1;

      if (pos < 0 || pos >= n) {
        std::cerr << "BAD UPDATE INDEX" << std::endl;
        exit(1);
      }

      modify(pos, val);
    } else if (type == 0) {
      // query
      cout<<"calculate= "<<calculate()<<endl;

      cout<<"dumb= "<<dumb()<<endl;

      assert(calculate()==dumb());

      //ans.push_back(calculate());
    } else {
      // bad operation type
      std::cerr << "BAD OPERATION TYPE" << std::endl;
      exit(1);
    }
  }

  return 0;
}
*/
  /*
    0 - query
    1 - update

    update structure:
    1 pos val
  */
