#include "minimize.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e5+6;
const ll MAXK=22;
const ll INF=2e18;
ll x[MAXN];
ll dp[MAXN][MAXK];
int n,k;
struct node
{
    ll best[MAXK];
    vector<ll>leftmostxors,rightmostxors;
    int l,r;
};
node mergen(node n1,node n2)
{
    node ret;ret.l=n1.l;ret.r=n2.r;
    for(int i=0;i<MAXK;i++)ret.best[i]=INF;
    for(int i1=0;i1<MAXK;i1++)
    {
        for(int i2=0;i1+i2<MAXK;i2++)
        {
            ret.best[i1+i2]=min(ret.best[i1+i2],n1.best[i1]+n2.best[i2]+x[n1.r]^x[n2.l]);
        }
    }
    for(int i1=0;i1<n1.rightmostxors.size()&&i1<MAXK;i1++)
    {
        for(int i2=0;i2<n2.leftmostxors.size()&&i2+i1<MAXK;i2++)
        {
            if(i1==0&&i2==0)continue;
            ll s1=n1.best[0]+n2.best[0];
            for(int j=0;j<i1;j++)s1-=n1.rightmostxors[j];
            for(int j=0;j<i2;j++)s1-=n2.leftmostxors[j];
            s1+=x[n1.r-i1]+x[n2.l+i2]-(x[n1.r-i1]&x[n2.l+i2]);
            ret.best[i1+i2]=min(ret.best[i1+i2],s1);
        }
    }
    ret.rightmostxors=n2.rightmostxors;
    ret.leftmostxors=n1.leftmostxors;
    for(int j=0;j<n1.rightmostxors.size()&&ret.rightmostxors.size()<MAXK-1;j++)ret.rightmostxors.push_back(n1.rightmostxors[j]);
    for(int j=0;j<n2.leftmostxors.size()&&ret.leftmostxors.size()<MAXK-1;j++)ret.leftmostxors.push_back(n2.leftmostxors[j]);
    return ret;
}
struct segment_tree
{

    node tree[3*MAXN];
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            for(int j=0;j<MAXK;j++)tree[idx].best[j]=0;
            tree[idx].l=l;
            tree[idx].r=r;
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
}st;
void initialize(int N,int K,vector<int>a)
{
    n=N;k=K;
    for(int i=0;i<a.size();i++)x[i+1]=a[i];
    st.build(1,n,1);
}
void modify(int pos,int val)
{
    x[pos+1]=val;
}
ll calculate()
{
    for(int j=0;j<=k;j++)
    {
        dp[0][j]=0;
    }
    for(int i=1;i<=n+1;i++)
    {
        for(int j=0;j<=k;j++)
        {
            dp[i][j]=dp[i-1][j];
            if(i!=1&&i!=n+1)dp[i][j]+=x[i]^x[i-1];
        }
        for(int state=1;state<=k;state++)
        {
            for(int use=1;use<=state;use++)
            {
                if(i<=n)
                {
                    if(i-use-1>0)dp[i][state]=min(dp[i][state],dp[i-use-1][state-use]+x[i]+x[i-use-1]-2*(x[i]&x[i-use-1]));
                    else dp[i][state]=min(dp[i][state],0ll);
                }
                else
                {
                    if(i-use-1<=0)dp[i][state]=min(dp[i][state],0ll);
                    else dp[i][state]=min(dp[i][state],dp[i-use-1][state-use]);
                }
            }
        }
        /*for(int j=0;j<=k;j++)
        {
            cout<<i<<" "<<j<<" "<<dp[i][j]<<endl;
        }*/
    }
    ll ans=INF;
    for(int i=0;i<=k;i++)ans=min(ans,dp[n+1][i]);
    return ans;
}