#include <algorithm>
#include <iostream>
#include <cassert>
#define int long long

const int maxn = 25;
const int maxm = 45;

int output[maxn];
char s[maxn][maxm];
int n, m, mod;
bool active[maxn];

void solve()
{
    std::string curr;
    for (int mask = 1 ; mask < (1 << n) ; ++mask)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            if (mask & (1 << i-1))
            {
                active[i] = 1;
            } else
            {
                active[i] = 0;
            }
        }
        curr = " ";
        for (int i = 1 ; i <= m ; ++i)
        {
            int cnt0 = 0;
            int cnt1 = 0;
            for (int j = 1 ; j <= n ; ++j)
            {
                if (!active[j]) continue;
                cnt0 += (s[j][i] == '0');
                cnt1 += (s[j][i] == '1');
            }

            for (int j = 1 ; j <= n ; ++j)
            {
                if (!active[j]) continue;
                if (cnt1 >= cnt0 && s[j][i] == '1') continue;
                if (cnt1 <= cnt0-1 && s[j][i] == '0') continue;
                active[j] = 0;
            }
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            output[i] += active[i];
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << (output[i] % mod) << ' ';
    }
    std::cout << '\n';
}

void read()
{
    std::cin >> n >> m >> mod;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s[i]+1;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}

/**

3 2 11
10
11
10

4 4 29
1011
1001
0110
0101

5 1 1000000007
1
1
0
0
0

*/
