#include "minimize.h"
#include <iostream>
#include <vector>

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll_loops")
#pragma GCC target ("sse4")

typedef long long llong;
const int maxn = 100000 + 10;
const int maxk = 25;

llong a[maxn], n, k;
llong dp[maxn][maxk];

void calcDP()
{
    for (int ix = n-1 ; ix >= 0 ; --ix)
    {
        for (int used = 0 ; used <= k ; ++used)
        {
            dp[ix][used] = dp[ix+1][used] + (ix == 0 ? 0 : a[ix] ^ a[ix+1]);
            for (int next = ix+2 ; next <= std::min(n+1, ix + (k - used) + 1) ; ++next)
            {
                llong add = (a[next] ^ a[ix]);
                if (ix == 0 || next == n+1) add = 0;
                dp[ix][used] = std::min(dp[ix][used], dp[next][used + next-ix-1] + add);
            }
        }
    }
}

void initialize(int N, int K, std::vector < int > v)
{
    n = N; k = K;
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = v[i-1];
    }
}

bool calced = 0;
void modify(int pos, int val)
{
    a[pos+1] = val;
    calced = 0;
}

llong calculate()
{
    if (!calced)
    {
        calcDP();
        calced = 1;
    }

    return dp[0][0];
}
