#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 4000;

struct node
{
    int cnt, le, ri;

    node(int cnt, int le, int ri)
    {
        this -> cnt = cnt;
        this -> le = le;
        this -> ri = ri;
    }
};

int n, m;
long long mod;
vector<node> v;
string s[MAXN + 5];
long long comb[MAXN + 5][MAXN + 5], dp[MAXN + 5][MAXN + 5];

void go(int curr, int pos, int i)
{
    if (pos == m)
    {
        for (int cnt1 = 1; cnt1 <= v[curr].cnt; ++ cnt1)
        {
            dp[pos][cnt1] = comb[v[curr].cnt - 1][cnt1 - 1];
        }
        return;
    }

    go((s[i][pos] == '1' ? v[curr].le : v[curr].ri), pos + 1, i);

    int lim1, lim2;
    if (s[i][pos] == '1')
    {
        lim1 = v[v[curr].le].cnt;
        lim2 = (v[curr].ri != -1 ? v[v[curr].ri].cnt : 0);
    }
    else
    {
        lim1 = v[v[curr].ri].cnt;
        lim2 = (v[curr].le != -1 ? v[v[curr].le].cnt : 0);
    }

    for (int cnt1 = 1; cnt1 <= lim1; ++ cnt1)
    {
        for (int cnt2 = 0; cnt2 <= min(cnt1 + (s[i][pos] == '1' ? 0 : -1), lim2); ++ cnt2)
        {
            dp[pos][cnt1 + cnt2] += (1ll * dp[pos + 1][cnt1] * comb[lim2][cnt2]) % mod;
            dp[pos][cnt1 + cnt2] %= mod;
        }
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> mod;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    v.emplace_back(0, -1, -1);
    for (int i = 1; i <= n; ++ i)
    {
        int curr = 0;
        for (int j = 0; j < m; ++ j)
        {
            v[curr].cnt++;
            if (s[i][j] == '1')
            {
                if (v[curr].le == -1)
                {
                    v[curr].le = v.size();
                    v.emplace_back(0, -1, -1);
                }
                curr = v[curr].le;
            }
            else
            {
                if (v[curr].ri == -1)
                {
                    v[curr].ri = v.size();
                    v.emplace_back(0, -1, -1);
                }
                curr = v[curr].ri;
            }
        }
        v[curr].cnt++;
    }

    comb[0][0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        comb[i][0] = 1;
        for (int j = 1; j <= i; ++ j)
        {
            comb[i][j] = (comb[i - 1][j] + comb[i - 1][j - 1]) % mod;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j <= m; ++ j)
        {
            for(int k = 0; k <= n; ++ k)
            {
                dp[j][k] = 0;
            }
        }

        go(0, 0, i);

        long long ans = 0;
        for (int k = 0; k <= n; ++ k)
        {
            ans += dp[0][k];
            ans %= mod;
        }
        cout << ans << " ";
    }
    cout << endl;

    return 0;
}
